package rankine;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.net.URL;
import rankine.steamtable.SteamTableReader;
import resourcemanager.WordMap;

//--------------------------------------------------------------------//
/**
 * LTCNAvbg CNX
 * @author aG
 * @version 1.0
 */
public class RankineCycleApplet extends Applet{

/** G[bZ[W */
  protected String message=null;

//--------------------------------------------------------------------//
/**
 * Avbg
 */
  public void init(){
    setLayout(new BorderLayout());
    RankineCycle cycle=getRankineCycle();
    Color bgColor=getTagColor("backgroundcolor");
    Color fgColor=getTagColor("foregroundcolor");
    Color subColor=getTagColor("subcolor");
    RankineCycleCanvas canvas=new RankineCycleCanvas
      (cycle,message,getTagFont(),bgColor,fgColor,subColor);
    add(canvas,BorderLayout.CENTER);
    add(new CycleControlPanel(canvas),BorderLayout.EAST);
  }

//--------------------------------------------------------------------//
/**
 * \[Xj
 */
  public void destroy(){
    removeAll();
  }

//--------------------------------------------------------------------//
/**
 * HTML^OŎw肳ꂽC\ǂݍ
 * @return HTML^OŎw肳ꂽC\f[^܂ރLTCN
 */
  public RankineCycle getRankineCycle(){
    String name=getParameter("steamtable");
    if(name==null) name="SteamTables.dat";
    try{
      Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
    }
    catch(SecurityException ex){
      message=ex.toString();
      return null;
    }
    RankineCycle cycle=new RankineCycle();
    try{
      SteamTableReader
      	reader=new SteamTableReader(cycle.getSteamTable());
      reader.read(new URL(getDocumentBase(),name));
      WordMap.read();
      return cycle;
    }
    catch(Exception ex){
      message=ex.toString();
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * HTML^OŎw肳ꂽFԂ
 * @param name p[^
 * @return HTML^OŎw肳ꂽF
 */
  protected Color getTagColor(String name){
    String value=getParameter(name);
    if(value==null) return Color.black;
    try{
      int rgb=Integer.parseInt(value,16);
      return new Color(rgb);
    }
    catch(NumberFormatException ex){
      return Color.BLACK;
    }
  }

//--------------------------------------------------------------------//
/**
 * HTML^OŎw肳ꂽtHgԂ
 * @return HTML^OŎw肳ꂽtHg
 */
  protected Font getTagFont(){
    String fontName=getParameter("fontname");
    if(fontName==null) fontName="Dialog";

    String s=getParameter("fontstyle");
    int fontStyle=Font.PLAIN;
    if(s!=null){
      if(s.equals("bold")){
      	fontStyle=Font.BOLD;
      }
      else if(s.equals("italic")){
      	fontStyle=Font.ITALIC;
      }
    }

    s=getParameter("fontsize");
    int fontSize=12;
    try{
      fontSize=Integer.parseInt(s);
    }
    catch(NumberFormatException ex){
    }

    return new Font(fontName,fontStyle,fontSize);
  }

//--------------------------------------------------------------------//
/**
 * AvbgԂ
 * @return Avbg܂ޕ
 */
  public String getAppletInfo(){
    return "Applet of rankine cycle\n"
      	  +"Author K.Higuchi";
  }

//--------------------------------------------------------------------//
/**
 * ̃Avbg߂p[^Ԃ
 * @return Avbg߂p[^i[z
 */
  public String[][] getParameterInfo(){
    return new String[][]{
      {"steamtable","String","Steam table data file name."},
      {"fontname","String","Font name. Default is Dialog."},
      {"fontstyle","int","Font style. Default is Font.PLAIN."},
      {"fontsize","int","Font size. Default is 12."},
      {"backgroundcolor","hexadecimal RGB number",
       "The color of background."},
      {"foregroundcolor","hexadecimal RGB number",
       "The color of foreground."},
      {"subcolor","hexadecimal RGB number","Gray or ight color."}
    };
  }
}
