package rankine.graph;
import java.awt.FontMetrics;
import java.awt.Graphics2D;
import rankine.NumberString;

//--------------------------------------------------------------------//
/**
 * Ot
 */
public class GraphAxis{

/** ڐ`TCY@*/
  public static final int SCALE_SIZE=4;

/** x@*/
  protected String name;

/** ͈͍ŏl@*/
  protected double scaleMin;

/** ͈͍ől@*/
  protected double scaleMax;

/** ڐ@*/
  protected double scale;

/** f[^|`ʒuϊW@*/
  protected double coef1;

/** f[^|`ʒuϊW@*/
  protected double coef0;

/**
 * Ot\z
 * @param name x
 */
  public GraphAxis(String name){
    this.name=name;
    scaleMin=0.0;
    scaleMax=1.0;
    scale=1.0;
    coef1=1.0;
    coef0=0.0;
  }

//--------------------------------------------------------------------//
/**
 * Otڐݒ肷
 * @param minValue f[^ŏl
 * @param maxValue f[^ől
 */
  public void setScale(double minValue,double maxValue){
    if(minValue>=maxValue){
      scaleMin=maxValue;
      scaleMax=maxValue+1.0;
      scale=1.0;
    }
    else{
      double xm=Math.max(Math.abs(minValue),Math.abs(maxValue));
      xm=Math.min(xm,maxValue-minValue);
      scale=Math.pow(10.0,Math.floor(Math.log(xm)/Math.log(10.0)));
      scaleMin=scale*Math.floor(minValue/scale);
      if(scaleMin==minValue) scaleMin-=scale;
      scaleMax=scale*Math.ceil(maxValue/scale);
      if(scaleMax==maxValue) scaleMax+=scale;
    }
  }

//--------------------------------------------------------------------//
/**
 * Wݒ肷
 * @param p0 ʒu
 * @param range \͈
 * @param direc @1F@-1F
 */
  public void setCoef(int p0,int range,int direc){
    coef1=(double)(direc*range)/(scaleMax-scaleMin);
    coef0=(double)p0-coef1*scaleMin;
  }

//--------------------------------------------------------------------//
/**
 * f[^`ʒuɕϊ
 * @param x f[^
 * @return `ʒu
 */
  public int toView(double x){
    return (int)(coef1*x+coef0);
  }

//--------------------------------------------------------------------//
/**
 * `ʒuf[^ɕϊ
 * @param x `ʒu
 * @return f[^
 */
  public double toData(int x){
    return ((double)x-coef0)/coef1;
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 * @param x0  <i>x</i> W
 * @param y0  <i>y</i> W
 * @param width \
 */
  public void paintHorizontal(Graphics2D g,int x0,int y0,int width){
    FontMetrics fm=g.getFontMetrics();
    g.drawLine(x0,y0,x0+width,y0);
    int ty=y0+fm.getAscent()+1;
    for(double s=scaleMin;s<=scaleMax;s+=scale){
      int x=toView(s);
      g.drawLine(x,y0,x,y0-SCALE_SIZE);
      String ss=NumberString.toString(s);
      g.drawString(ss,x-fm.stringWidth(ss)/2,ty);
    }
    g.drawString(name,x0+(width-fm.stringWidth(name))/2,
      	      	 ty+fm.getHeight());
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 * @param x0  <i>x</i> W
 * @param y0  <i>y</i> W
 * @param height \
 */
  public void paintVertical(Graphics2D g,int x0,int y0,int height){
    FontMetrics fm=g.getFontMetrics();
    g.drawLine(x0,y0,x0,y0+height);
    int dy=fm.getHeight()/2-fm.getDescent();
    for(double s=scaleMin;s<=scaleMax;s+=scale){
      int y=toView(s);
      g.drawLine(x0,y,x0+SCALE_SIZE,y);
      String ss=NumberString.toString(s);
      g.drawString(ss,x0-fm.stringWidth(ss)-1,y+dy);
    }
    g.drawString(name,x0-fm.stringWidth(name)/2,
      	      	 y0+dy-fm.getHeight()-1);
  }
}
