package rankine.graph;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.geom.Point2D;

//--------------------------------------------------------------------//
/**
 * Ot
 */
public class GraphWindow extends Rectangle{

/** OaC}̓_f[^i[z */
  protected Point2D p1[];

/** TCN̓_f[^i[z */
  protected Point2D p2[];

/** <i>x</i>  */
  protected GraphAxis xAxis;

/** <i>y</i>  */
  protected GraphAxis yAxis;

/**
 * Ot\z
 * @param xLabel <i>x</i> x
 * @param yLabel <i>y</i> x
 */
  public GraphWindow(String xLabel,String yLabel){
    this(xLabel,false,yLabel,false);
  }

/**
 * Ot\z
 * @param xLabel <i>x</i> x
 * @param xIsLog <i>x</i> ΐ͏ꍇ true
 * @param yLabel <i>y</i> x
 * @param yIsLog <i>x</i> ΐ͏ꍇ true
 */
  public GraphWindow(String xLabel,boolean xIsLog,
      	      	     String yLabel,boolean yIsLog){
    super();
    p1=new Point2D[0];
    p2=new Point2D[0];
    if(xIsLog){
      xAxis=new LogAxis(xLabel);
    }
    else{
      xAxis=new GraphAxis(xLabel);
    }
    if(yIsLog){
      yAxis=new LogAxis(yLabel);
    }
    else{
      yAxis=new GraphAxis(yLabel);
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^ݒ肷
 * @param p1 OaC}̓_f[^i[z
 * @param p2 TCN̓_f[^i[z
 */
  public void setData(Point2D p1[],Point2D p2[]){
    this.p1=p1;
    this.p2=p2;
  }

//--------------------------------------------------------------------//
/**
 * f[^ݒ肷
 */
  public void setAxis(){
    if(p2.length>0){
      double large=java.lang.Double.MAX_VALUE;
      double xMin=large;
      double xMax=-large;
      double yMin=large;
      double yMax=-large;
      for(int i=0;i<p2.length;i++){
      	xMin=Math.min(xMin,p2[i].getX());
      	xMax=Math.max(xMax,p2[i].getX());
      	yMin=Math.min(yMin,p2[i].getY());
      	yMax=Math.max(yMax,p2[i].getY());
      }
      xAxis.setScale(xMin,xMax);
      yAxis.setScale(yMin,yMax);
    }
    xAxis.setCoef(x,width,1);
    yAxis.setCoef(y+height,height,-1);
  }

//--------------------------------------------------------------------//
/**
 * Ot`悷
 * @param g `悷OtBbNXReLXg
 * @param fgColor OiF
 * @param subColor F
 */
  public void paint(Graphics2D g,Color fgColor,Color subColor){
    g.setColor(subColor);
    paintData(g,p1,false);
    g.setColor(fgColor);
    paintData(g,p2,true);
    paintBorder(g);
  }

//--------------------------------------------------------------------//
/**
 * Otf[^`悷
 * @param g `悷OtBbNXReLXg
 * @param p _f[^i[z
 * @param closed OtĂꍇ true
 */
  protected void paintData(Graphics2D g,Point2D p[],boolean closed){
    if(p.length==0) return;
    int length=p.length;
    if(closed) length++;
    int x1=xAxis.toView(p[0].getX());
    int y1=yAxis.toView(p[0].getY());
    boolean contain1=containsBorder(x1,y1);
    for(int i=1;i<length;i++){
      int ii=i%p.length;
      int x2=xAxis.toView(p[ii].getX());
      int y2=yAxis.toView(p[ii].getY());
      boolean contain2=containsBorder(x2,y2);
      if(contain1 && contain2){
      	g.drawLine(x1,y1,x2,y2);
      }
      else if(contain1){
      	paintLineBorders(g,x1,y1,x2,y2);
      }
      else if(contain2){
      	paintLineBorders(g,x2,y2,x1,y1);
      }
      x1=x2;
      y1=y2;
      contain1=contain2;
    }
  }

//--------------------------------------------------------------------//
/**
 * E܂͓ǂA
 * @param px _ <i>x</i> W
 * @param py _ <i>y</i> W
 * @return ^ꂽ_̘g̓܂͋Eɂꍇ true
 */
  protected boolean containsBorder(int px,int py){
    return ((x<=px) && (px<=x+width) && (y<=py) && (py<=y+height));
  }

//--------------------------------------------------------------------//
/**
 * gׂOt`悷
 * @param g `悷OtBbNXReLXg
 * @param x1 ̈̓_ <i>x</i> W
 * @param y1 ̈̓_ <i>y</i> W
 * @param x2 ̈O̓_ <i>x</i> W
 * @param y2 ̈O̓_ <i>y</i> W
 */
  protected void paintLineBorders(Graphics2D g,int x1,int y1,
      	      	      	      	  int x2,int y2){
    if(x2<x){
      int yy=(y2-y1)*(x-x1)/(x2-x1)+y1;
      if(yy<y){
      	int xx=(x2-x1)*(y-y1)/(y2-y1)+x1;
      	g.drawLine(x1,y1,xx,y);
      }
      else if(yy>y+height){
      	int xx=(x2-x1)*(y+height-y1)/(y2-y1)+x1;
      	g.drawLine(x1,y1,xx,y+height);
      }
      else{
      	g.drawLine(x1,y1,x,yy);
      }
    }
    else if(x2>x+width){
      int yy=(y2-y1)*(x+width-x1)/(x2-x1)+y1;
      if(yy<y){
      	int xx=(x2-x1)*(y-y1)/(y2-y1)+x1;
      	g.drawLine(x1,y1,xx,y);
      }
      else if(yy>y+height){
      	int xx=(x2-x1)*(y+height-y1)/(y2-y1)+x1;
      	g.drawLine(x1,y1,xx,y+height);
      }
      else{
      	g.drawLine(x1,y1,x+width,yy);
      }
    }
    else if(y2<y){
      int xx=(x2-x1)*(y-y1)/(y2-y1)+x1;
      g.drawLine(x1,y1,xx,y);
    }
    else if(y2>y+height){
      int xx=(x2-x1)*(y+height-y1)/(y2-y1)+x1;
      g.drawLine(x1,y1,xx,y+height);
    }
  }

//--------------------------------------------------------------------//
/**
 * Otg`悷
 * @param g `悷OtBbNXReLXg
 */
  protected void paintBorder(Graphics2D g){
    g.drawRect(x,y,width,height);
    xAxis.paintHorizontal(g,x,y+height,width);
    yAxis.paintVertical(g,x,y,height);
  }
}
