package rankine.graph;
import java.awt.FontMetrics;
import java.awt.Graphics2D;

//--------------------------------------------------------------------//
/**
 * Otΐ
 */
public class LogAxis extends GraphAxis{

/**
 * Ot\z
 * @param name x
 */
  public LogAxis(String name){
    super(name);
  }

//--------------------------------------------------------------------//
/**
 * Otڐݒ肷
 * @param minValue f[^ŏl
 * @param maxValue f[^ől
 */
  public void setScale(double minValue,double maxValue){
    if((minValue>=maxValue) || (minValue<=0.0)){
      scaleMin=Math.floor(Math.log(maxValue)/Math.log(10.0));
      scaleMax=scaleMin+1.0;
      scale=1.0;
    }
    else{
      scale=1.0;
      scaleMin=Math.floor(Math.log(minValue)/Math.log(10.0));
      scaleMax=Math.ceil(Math.log(maxValue)/Math.log(10.0));
    }
  }

//--------------------------------------------------------------------//
/**
 * Wݒ肷
 * @param p0 ʒu
 * @param range \͈
 * @param direc @1F@-1F
 */
  public void setCoef(int p0,int range,int direc){
    coef1=(double)(direc*range)/((scaleMax-scaleMin)*Math.log(10.0));
    coef0=(double)p0-coef1*scaleMin*Math.log(10.0);
  }

//--------------------------------------------------------------------//
/**
 * f[^`ʒuɕϊ
 * @param x f[^
 * @return `ʒu
 */
  public int toView(double x){
    return (int)(coef1*Math.log(x)+coef0);
  }

//--------------------------------------------------------------------//
/**
 * `ʒuf[^ɕϊ
 * @param x `ʒu
 * @return f[^
 */
  public double toData(int x){
    return Math.exp(((double)x-coef0)/coef1);
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 * @param x0  <i>x</i> W
 * @param y0  <i>y</i> W
 * @param width \
 */
  public void paintHorizontal(Graphics2D g,int x0,int y0,int width){
    FontMetrics fm=g.getFontMetrics();
    g.drawLine(x0,y0,x0+width,y0);
    int ty=y0+fm.getAscent()+1;
    for(double s=scaleMin;s<=scaleMax;s+=scale){
      int x=toView(Math.pow(10.0,s));
      g.drawLine(x,y0,x,y0-SCALE_SIZE);
      String ss=toLabel(s);
      g.drawString(ss,x-fm.stringWidth(ss)/2,ty);
    }
    g.drawString(name,x0+(width-fm.stringWidth(name))/2,
      	      	 ty+fm.getHeight());
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 * @param x0  <i>x</i> W
 * @param y0  <i>y</i> W
 * @param height \
 */
  public void paintVertical(Graphics2D g,int x0,int y0,int height){
    FontMetrics fm=g.getFontMetrics();
    g.drawLine(x0,y0,x0,y0+height);
    int dy=fm.getHeight()/2-fm.getDescent();
    for(double s=scaleMin;s<=scaleMax;s+=scale){
      int y=toView(Math.pow(10.0,s));
      g.drawLine(x0,y,x0+SCALE_SIZE,y);
      String ss=toLabel(s);
      g.drawString(ss,x0-fm.stringWidth(ss)-1,y+dy);
    }
    g.drawString(name,x0-fm.stringWidth(name)/2,
      	      	 y0+dy-fm.getHeight()-1);
  }

//--------------------------------------------------------------------//
/**
 * ڐ̐l𕶎ɕϊ
 * @param s l
 * @return 
 */
  protected String toLabel(double s){
    return "10^"+String.valueOf((int)s);
  }
}
