package rankine.steamtable;

//--------------------------------------------------------------------//
/**
 * ̓f[^
 */
public class PressureTable{

/** f[^ */
  protected int count;

/** xi[z */
  protected double t[];

/** p[^i[z */
  protected VaporVariable vv[];

/**
 * ̓f[^\z
 */
  public PressureTable(){
    count=0;
    t=new double[count];
    vv=new VaporVariable[count];
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return f[^
 */
  public int getCount(){
    return count;
  }

//--------------------------------------------------------------------//
/**
 * f[^ݒ肷
 * @param count f[^
 */
  public void setCount(int count){
    this.count=count;
    t=new double[count];
    vv=new VaporVariable[count];
  }

//--------------------------------------------------------------------//
/**
 * f[^ݒ肷
 * @param index f[^̃CfbNX
 * @param t x
 * @param vv p[^
 */
  public void setParameter(int index,double t,VaporVariable vv){
    this.t[index]=t;
    this.vv[index]=vv;
  }

//--------------------------------------------------------------------//
/**
 * xf[^͈͂𒴂Ă邩ǂԂ
 * @param tt x
 * @return xf[^͈͂𒴂Ăꍇ true
 */
  public boolean isOverT(double tt){
    if(t[0]<t[count-1]){
      return ((tt<t[0]) || (t[count-1]<tt));
    }
    else{
      return ((tt>t[0]) || (t[count-1]>tt));
    }
  }

//--------------------------------------------------------------------//
/**
 * Ggs[f[^͈͂𒴂Ă邩ǂԂ
 * @param ss Ggs[
 * @return Ggs[f[^͈͂𒴂Ăꍇ true
 */
  public boolean isOverS(double ss){
    if(vv[0].s<vv[count-1].s){
      return ((ss<vv[0].s) || (vv[count-1].s<ss));
    }
    else{
      return ((ss>vv[0].s) || (vv[count-1].s>ss));
    }
  }

//--------------------------------------------------------------------//
/**
 * xɑΉf[^Ԃ
 * @param pp 
 * @param tt x
 * @return ԗ
 */
  public StateVariable getByT(double pp,double tt){
    if(t[0]<t[count-1]){
      if(tt<=t[0]){
      	return new StateVariable(t[0],pp,vv[0]);
      }
      else if(tt>=t[count-1]){
      	return new StateVariable(t[count-1],pp,vv[count-1]);
      }
    }
    else{
      if(tt>=t[0]){
      	return new StateVariable(t[0],pp,vv[0]);
      }
      else if(tt<=t[count-1]){
      	return new StateVariable(t[count-1],pp,vv[count-1]);
      }
    }
    int i=serachIndex(0,count-1,tt,t);
    double cc=(tt-t[i])/(t[i+1]-t[i]);
    return new StateVariable(tt,pp,vv[i].v+cc*(vv[i+1].v-vv[i].v),
      	      	      	     vv[i].u+cc*(vv[i+1].u-vv[i].u),
      	      	      	     vv[i].h+cc*(vv[i+1].h-vv[i].h),
      	      	      	     vv[i].s+cc*(vv[i+1].s-vv[i].s));
  }

//--------------------------------------------------------------------//
/**
 * Ggs[ɑΉf[^Ԃ
 * @param pp 
 * @param ss Ggs[
 * @return ԗ
 */
  public StateVariable getByS(double pp,double ss){
    if(vv[0].s<vv[count-1].s){
      if(ss<=vv[0].s){
      	return new StateVariable(t[0],pp,vv[0]);
      }
      else if(ss>=vv[count-1].s){
      	return new StateVariable(t[count-1],pp,vv[count-1]);
      }
    }
    else{
      if(ss>=vv[0].s){
      	return new StateVariable(t[0],pp,vv[0]);
      }
      else if(ss<=vv[count-1].s){
      	return new StateVariable(t[count-1],pp,vv[count-1]);
      }
    }
    int i=serachIndex(0,count-1,ss,vv);
    double cc=(ss-vv[i].s)/(vv[i+1].s-vv[i].s);
    return new StateVariable(t[i]+cc*(t[i+1]-t[i]),pp,
      	      	      	     vv[i].v+cc*(vv[i+1].v-vv[i].v),
      	      	      	     vv[i].u+cc*(vv[i+1].u-vv[i].u),
      	      	      	     vv[i].h+cc*(vv[i+1].h-vv[i].h),ss);
  }

//--------------------------------------------------------------------//
/**
 * f[^YCfbNX
 * @param low CfbNX̉
 * @param high CfbNX̏
 * @param v f[^̒l
 * @param array f[^z
 * @return z񒆂̃f[^菬̍ő̒l̃CfbNX
 */
  static int serachIndex(int low,int high,double v,double array[]){
    if(array[low]<array[high]){
      do{
      	int mid=(low+high)/2;
      	if(array[mid]<=v)     low=mid+1;
      	else if(array[mid]>v) high=mid;
      }while(low<high);
    }
    else{
      do{
      	int mid=(low+high)/2;
      	if(array[mid]>=v)     low=mid+1;
      	else if(array[mid]<v) high=mid;
      }while(low<high);
    }
    return (low+high)/2-1;
  }

//--------------------------------------------------------------------//
/**
 * f[^YCfbNX
 * @param low CfbNX̉
 * @param high CfbNX̏
 * @param v f[^̒l
 * @param vv f[^z
 * @return z񒆂̃f[^菬̍ő̒l̃CfbNX
 */
  static int serachIndex(int low,int high,double v,VaporVariable vv[]){
    if(vv[low].s<vv[high].s){
      do{
      	int mid=(low+high)/2;
      	if(vv[mid].s<=v)     low=mid+1;
      	else if(vv[mid].s>v) high=mid;
      }while(low<high);
    }
    else{
      do{
      	int mid=(low+high)/2;
      	if(vv[mid].s>=v)     low=mid+1;
      	else if(vv[mid].s<v) high=mid;
      }while(low<high);
    }
    return (low+high)/2-1;
  }
}
