package rankine.steamtable;
import java.io.BufferedReader;
import java.util.StringTokenizer;
import fileio.TextDataReader;

//--------------------------------------------------------------------//
/**
 * C\ǂݍ݃NX
 */
public class SteamTableReader extends TextDataReader{

/** C\ */
  protected SteamTable table;

/**
 * C\ǂݍ݃IuWFNg\z
 * @param table C\
 */
  public SteamTableReader(SteamTable table){
    this.table=table;
  }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param br ̓[_[
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  public void readData(BufferedReader br) throws Exception{
    SaturatedVapor sv=table.getSaturatedVapor();
    TableData hv=table.getSuperHeatedVapor();
    TableData cw=table.getCompressedWater();

    while(true){
      String line=br.readLine();
      if(line==null) break;
      StringTokenizer st=new StringTokenizer(line);
      int length=st.countTokens();
      if(length>=2){
      	String word=st.nextToken().toLowerCase();
      	if(word.equals("saturatedvapor")){
      	  int count=Integer.parseInt(st.nextToken());
      	  sv.setCount(count);
      	  for(int i=0;i<count;i++){
      	    st=new StringTokenizer(br.readLine());
      	    if(st.countTokens()>=10){
      	      sv.setParameter(i,Double.parseDouble(st.nextToken()),
      	      	      	      Double.parseDouble(st.nextToken()),
      	      	      	      readVaporVariable(st),
      	      	      	      readVaporVariable(st));
      	    }
      	  }
      	}
      	else if(word.equals("superheatedvapor")){
      	  int count=Integer.parseInt(st.nextToken());
      	  hv.setCount(count);
      	  for(int i=0;i<count;i++){
      	    st=new StringTokenizer(br.readLine());
      	    double p=Double.parseDouble(st.nextToken());
      	    int m=Integer.parseInt(st.nextToken());
      	    hv.setCount(i,m);
      	    hv.setPressure(i,p);
      	    for(int j=0;j<m;j++){
      	      st=new StringTokenizer(br.readLine());
      	      if(st.countTokens()>=5){
      	      	hv.setParameter(i,j,Double.parseDouble(st.nextToken()),
      	      	      	      	readVaporVariable(st));
      	      }
      	    }
      	  }
      	}
      	else if(word.equals("compressedwater")){
      	  int count=Integer.parseInt(st.nextToken());
      	  cw.setCount(count);
      	  for(int i=0;i<count;i++){
      	    st=new StringTokenizer(br.readLine());
      	    double p=Double.parseDouble(st.nextToken());
      	    int m=Integer.parseInt(st.nextToken());
      	    cw.setCount(i,m);
      	    cw.setPressure(i,p);
      	    for(int j=0;j<m;j++){
      	      st=new StringTokenizer(br.readLine());
      	      if(st.countTokens()>=5){
      	      	cw.setParameter(i,j,Double.parseDouble(st.nextToken()),
      	      	      	      	readVaporVariable(st));
      	      }
      	    }
      	  }
      	}
      }
    }
    br.close();
  }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param st f[^ǂݍ <code>StringTokenizer</code>
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  protected VaporVariable readVaporVariable(StringTokenizer st){
    if(st.countTokens()<4) return null;
    try{
      double v=Double.parseDouble(st.nextToken());
      double u=Double.parseDouble(st.nextToken());
      double h=Double.parseDouble(st.nextToken());
      double s=Double.parseDouble(st.nextToken());
      return new VaporVariable(v,u,h,s);
    }
    catch(NumberFormatException ex){
      return null;
    }
  }
}
