package rankine.steamtable;

//--------------------------------------------------------------------//
/**
 * \f[^
 */
public class TableData{

/** ̓f[^ */
  protected int count;

/** ͂i[z */
  protected double p[];

/** p[^i[z */
  protected PressureTable data[];

/**
 * \f[^\z
 */
  public TableData(){
    count=0;
    p=new double[count];
    data=new PressureTable[count];
  }

//--------------------------------------------------------------------//
/**
 * ̓f[^Ԃ
 * @return ̓f[^
 */
  public int getCount(){
    return count;
  }

//--------------------------------------------------------------------//
/**
 * ̓f[^ݒ肷
 * @param count ̓f[^
 */
  public void setCount(int count){
    this.count=count;
    p=new double[count];
    data=new PressureTable[count];
    for(int i=0;i<count;i++){
      data[i]=new PressureTable();
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^ݒ肷
 * @param index ̓f[^̃CfbNX
 * @param count xf[^
 */
  public void setCount(int index,int count){
    data[index].setCount(count);
  }

//--------------------------------------------------------------------//
/**
 * ͂ݒ肷
 * @param index ͂̃CfbNX
 * @param p 
 */
  public void setPressure(int index,double p){
    this.p[index]=p;
  }

//--------------------------------------------------------------------//
/**
 * f[^ݒ肷
 * @param index1 ͂̃CfbNX
 * @param index2 xf[^̃CfbNX
 * @param t x
 * @param vp p[^
 */
  public void setParameter(int index1,int index2,double t,
      	      	      	   VaporVariable vp){
    data[index1].setParameter(index2,t,vp);
  }

//--------------------------------------------------------------------//
/**
 * ́ExɑΉf[^Ԃ
 * @param pp 
 * @param tt x
 * @return ԗ
 */
  public StateVariable getByPT(double pp,double tt){
    if(pp<=p[0]){
      return data[0].getByT(pp,tt);
    }
    else if(pp>=p[count-1]){
      return data[count-1].getByT(pp,tt);
    }
    else{
      int i=PressureTable.serachIndex(0,count-1,pp,p);
      double cc=(pp-p[i])/(p[i+1]-p[i]);
      StateVariable sv1=data[i].getByT(pp,tt);
      StateVariable sv2=data[i+1].getByT(pp,tt);
      if(data[i].isOverT(tt)){
      	StateVariable sv3=data[i+1].getByT(pp,(tt+(cc-1.0)*sv1.t)/cc);
      	return new StateVariable(tt,pp,sv1.v+cc*(sv3.v-sv1.v),
      	      	      	      	 sv1.u+cc*(sv3.u-sv1.u),
      	      	      	      	 sv1.h+cc*(sv3.h-sv1.h),
      	      	      	      	 sv1.s+cc*(sv3.s-sv1.s));
      }
      else if(data[i+1].isOverT(tt)){
      	StateVariable sv3=data[i].getByT(pp,(tt-cc*sv2.t)/(1.0-cc));
      	return new StateVariable(tt,pp,sv3.v+cc*(sv2.v-sv3.v),
      	      	      	      	 sv3.u+cc*(sv2.u-sv3.u),
      	      	      	      	 sv3.h+cc*(sv2.h-sv3.h),
      	      	      	      	 sv3.s+cc*(sv2.s-sv3.s));
      }
      else{
      	return new StateVariable(tt,pp,sv1.v+cc*(sv2.v-sv1.v),
      	      	      	      	 sv1.u+cc*(sv2.u-sv1.u),
      	      	      	      	 sv1.h+cc*(sv2.h-sv1.h),
      	      	      	      	 sv1.s+cc*(sv2.s-sv1.s));
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * ́EGgs[ɑΉf[^Ԃ
 * @param pp 
 * @param ss Ggs[
 * @return ԗ
 */
  public StateVariable getByPS(double pp,double ss){
    if(pp<=p[0]){
      return data[0].getByS(pp,ss);
    }
    else if(pp>=p[count-1]){
      return data[count-1].getByS(pp,ss);
    }
    else{
      int i=PressureTable.serachIndex(0,count-1,pp,p);
      double cc=(pp-p[i])/(p[i+1]-p[i]);
      StateVariable sv1=data[i].getByS(pp,ss);
      StateVariable sv2=data[i+1].getByS(pp,ss);
      if(data[i].isOverS(ss)){
      	StateVariable sv3=data[i+1].getByS(pp,(ss+(cc-1.0)*sv1.s)/cc);
      	return new StateVariable(sv1.t+cc*(sv3.t-sv1.t),pp,
      	      	      	      	 sv1.v+cc*(sv3.v-sv1.v),
      	      	      	      	 sv1.u+cc*(sv3.u-sv1.u),
      	      	      	      	 sv1.h+cc*(sv3.h-sv1.h),ss);
      }
      else if(data[i+1].isOverS(ss)){
      	StateVariable sv3=data[i].getByS(pp,(ss-cc*sv2.s)/(1.0-cc));
      	return new StateVariable(sv3.t+cc*(sv2.t-sv3.t),pp,
      	      	      	      	 sv3.v+cc*(sv2.v-sv3.v),
      	      	      	      	 sv3.u+cc*(sv2.u-sv3.u),
      	      	      	      	 sv3.h+cc*(sv2.h-sv3.h),ss);
      }
      else{
      	return new StateVariable(sv1.t+cc*(sv2.t-sv1.t),pp,
      	      	      	      	 sv1.v+cc*(sv2.v-sv1.v),
      	      	      	      	 sv1.u+cc*(sv2.u-sv1.u),
      	      	      	      	 sv1.h+cc*(sv2.h-sv1.h),ss);
      }
    }
  }
}
